﻿#include <oxstd.h>
#include <oxprob.h>
#include <oxgauss.h>

main()
{
  decl N, T, TT, TI, P, B, C, J, M, BT, BTI, CT, CTI, BS, AS, BSI, ASI, BM, AM, BBM, AAM, Q, H, R, EP,
       SS, S, MITC;
  decl YD, YDI, YY, YYI, YYIT, YC, YCI, YCIT, YB, YBI, YBIT, YYB, YYBI, YYBIT, XSC, XSCI, XC, XCI, XCIT, XXCIT, XB, XBI, XI,
       XBIT, XXBIT, XIT, XXIT, XITB, XBITB;
  decl ZZ, ZI, ZIT, ZBO, ZBC, WW, WI, WIT, SSETI, YCNUM, VS, VSI, VV, VVI, VVIT, VIT, UU, UUI, UUIT, VU, VUI, VUIT,
       VSU, VSUI, VSUIT, TEM, MUV, MUU, MUVU;
  decl AL, GA, BE, PH, GAI, BEI, ALI, TH, VB1, VB11, VB12, VB2, VB21, VB22, VB22_1, VB22_2, VB22_3, VB22_4, VB, VG, VG2, PS,
       VET, ET, SIG, SIGU, SIGL, SIG2, SIGB, RHO, LAM, LAM2;
  decl i, j, w, b, c, d, ds, bs, ru, u, s, ku, a, v, mm, mmo;
  decl DI, DDI, CI, IIC, II, DE, MUD, MAXU, UISM, S1, IIBS;
  decl TRUETH, TRUEVB, TRUEPH, TRUEVG, TRUELAM, TRUESIG;
  decl TRUETH_OUT, TRUEVB_OUT, TRUEPH_OUT, TRUEVG_OUT, TRUEGA_OUT, TRUEBE_OUT, TRUEPS_OUT, TRUEVET_OUT, TRUEET_OUT,
       TRUESIG_OUT, TRUERHO_OUT, TRUELAM_OUT;
  decl YYDATA_OUT, YCDATA_OUT, YBDATA_OUT, YDDATA_OUT, VVDATA_OUT, VSDATA_OUT, UUDATA_OUT, VUDATA_OUT, VSUDATA_OUT,
	   TTDATA_OUT, SSDATA_OUT, XCDATA_OUT, XSCDATA_OUT, XBDATA_OUT, ZZDATA_OUT, WWDATA_OUT;

  decl THDATA, VBDATA, PHDATA, VGDATA, BEDATA, GADATA, LAMDATA, SIGDATA, THDATA_OUT, VBDATA_OUT, PHDATA_OUT, VGDATA_OUT,
       BEDATA_OUT, GADATA_OUT, LAMDATA_OUT, SIGDATA_OUT;
	   
  decl TBE_OUT, TLAM_OUT;
  
  decl BURN, KAI, NUM;
  decl KAI_OUT, TTH_OUT, TVB_OUT, TPH_OUT, TVG_OUT, TSIG_OUT;
  decl PRMT, PRVT;
  decl TGA_OUT, TRHO_OUT, TPS_OUT;
  decl PS2;
  
  decl ZZ1, ZZ2, ZZ1DATA_OUT, ZZ2DATA_OUT, SUM, SEED; 

// ∑
  decl VULW, IRN, DD, N0P, P0P, NNP, PN, IPN;
// Λ
  decl GB, AG, OM, OMI, UL, UIM, OR, UR, HATG, TILLG, TILG, SUUA, GAMMA, M0T, V0T;
//β
  decl M0B, V0B, OIT,  SIGT, MGI, VGI, BL, BBL, XIX, XIK, VBL, MBL, MBI, VBI;
// θ
  decl MT0, VT0, VTH, BBE, MTH, NL, MTL0, STL0;
// φ
  decl MPL0, SPL0, MP0, VP0, VPH, GGA, MPH;
// Vβ
  decl SB0, RB0, NNB, PSNB, IPSNB;
  decl SBL0, RBL0, SBNL, RBNL, LK, TTHL, BTL, IRBNL;
// Vγ
  decl SG0, RG0, NNG, PSNG, IPSNG;
  decl SGL0, RGL0, SGNL, RGNL, PPHL, GTL, IRGNL;
//γ_i
  decl M0G, V0G, MG, SI, BXI, PSS, VGL, MGL, LVEC, LKI, TM, CTCM, LKIS, BKI, EGS, PSSL;
// v and u
  decl MU, ISIG, SBB, SB, UC, MUC, GG, TBV, TB, MIC, FF0, FUF, VIBS, SYB, UIBS, UUC, MAU, LLAM,
       TBKI, SSIG, LS, ILS, MUT;
	   
  format(30000);


N = 1000;  /*number of consumers*/
B = 3;  /*number of brands*/
C = B + 1;

BURN = 1000;   /*Burn-in*/
KAI = 10000;   /*MCMC iteration*/
NUM = KAI - BURN;

M = 1;
BM = B*M;
BBM = B*B*M;

J = 5;  /*the number of the explanatory variables for product category purchase*/

Q = B + 3;  /*the number of the explanatory variables for multiple brand purchase*/

P = J + Q;
T = 20;  /*the number of purchase occasions*/

BT = B*T;
CT = C*T;

TRUETH = zeros(J,1);
TRUETH = <
 0.3;

-0.5;
 0.5;
 0.5;
 
-0.02
>;

TRUEVB = zeros(J,J);
TRUEVB = 0.05*unit(J);

TRUEPH = zeros(Q,1);
TRUEPH = <
-0.2;
-0.4;
-0.6;
 
-1.0;
 1.0;
 1.0
>;

TRUEVG = zeros(Q,Q);
TRUEVG = 0.05*unit(Q);

TRUELAM = zeros(B,BM);
TRUELAM = <
 0.7, -0.1, -0.1;
-0.1,  0.7,	-0.1;
-0.1, -0.1,  0.7
>;

TRUESIG = zeros(C,C);
TRUESIG = <
 1.0,    0,    0,    0;
   0,  1.0, -0.4, -0.4;
   0, -0.4,  1.0, -0.4;
   0, -0.4, -0.4,  1.0
>;




////////////////////////////////// validation data ///////////////////////////////////////////

SEED = 100;
ranseed(SEED);

TH = TRUETH;
VB = TRUEVB;
PH = TRUEPH;
VG = TRUEVG;
LAM = TRUELAM;
SIG = TRUESIG;

TT = T*ones(N,1);

TTDATA_OUT = fopen("(file path)\TTDATA_VALIDATION.txt","w");
fprint(TTDATA_OUT,"%5.0f",TT);
fclose(TTDATA_OUT);

TRUETH_OUT = fopen("(file path)\TRUETH.txt","w");
fprint(TRUETH_OUT,"%10.5f",TH);
fclose(TRUETH_OUT);

TRUEVB_OUT = fopen("(file path)\TRUEVB.txt","w");
fprint(TRUEVB_OUT,"%10.5f",VB);
fclose(TRUEVB_OUT);

TRUEPH_OUT = fopen("(file path)\TRUEPH.txt","w");
fprint(TRUEPH_OUT,"%10.5f",PH);
fclose(TRUEPH_OUT);

TRUEVG_OUT = fopen("(file path)\TRUEVG.txt","w");
fprint(TRUEVG_OUT,"%10.5f",VG);
fclose(TRUEVG_OUT);

TRUELAM_OUT = fopen("(file path)\TRUELAM.txt","w");
fprint(TRUELAM_OUT,"%5.1f",LAM);
fclose(TRUELAM_OUT);

TRUESIG_OUT = fopen("(file path)\TRUESIG.txt","w");
fprint(TRUESIG_OUT,"%5.1f",SIG);
fclose(TRUESIG_OUT);


BE = zeros(N,J);
for(i=0; i<N; ++i){
  BEI = zeros(J,1);
  BEI = TH + choleski(VB)*rann(J,1);

BE[i][] = BEI';
}


GA = zeros(N,Q);
for(i=0; i<N; ++i){
  GAI = zeros(Q,1);
  GAI = PH + choleski(VG)*rann(Q,1);

GA[i][] = GAI';
}


TRUEBE_OUT = fopen("(file path)\TRUEBE_VALIDATION.txt","w");
fprint(TRUEBE_OUT,"%10.5f",BE);
fclose(TRUEBE_OUT);

TRUEGA_OUT = fopen("(file path)\TRUEGA_VALIDATION.txt","w");
fprint(TRUEGA_OUT,"%10.5f",GA);
fclose(TRUEGA_OUT);


/*matrices of the explanatory variables for product category purchase*/
XB = zeros(N*Q,BT);  /*matrix for brand purchase*/
XC = zeros(N,J*T);  /*matrix for product category purchase*/

for(i=0; i<N; ++i){
  TI = TT[i];
  XBI = zeros(BT,Q);
  XCI = zeros(J*T,1);
  
  for(u=0; u<TI; ++u){
	XBIT = zeros(B,3);
    XCIT = zeros(J,1);
	
    for(d=0; d<B; ++d){
      XITB = zeros(1,3);

      TEM = 0.5*rann(1,1);
	  XITB[0][0] = TEM;

      TEM = 0.5*rann(1,1);
	  XITB[0][1] = TEM;

      TEM = 0.5*rann(1,1);
	  XITB[0][2] = TEM;

	  XBIT[d][] = XITB;
	}  /*B*/
	
	XBIT = unit(B) ~ XBIT;

    XCIT[0][0] = 1.0;	/*intercept*/
    for(d=1; d<J; ++d){
      TEM = 0.5*rann(1,1);
      XCIT[d][0] = TEM;  
    }

  XBI[u*B:(u+1)*B-1][] = XBIT;
  XCI[u*J:(u+1)*J-1][] = XCIT;
  }  /*TI*/

XB[i*Q:(i+1)*Q-1][0:BT-1] = XBI';
XC[i][] = XCI';
}


XBDATA_OUT = fopen("(file path)\XBDATA_VALIDATION.txt","w");
fprint(XBDATA_OUT,"%15.10f",XB);
fclose(XBDATA_OUT);

XCDATA_OUT = fopen("(file path)\XCDATA_VALIDATION.txt","w");
fprint(XCDATA_OUT,"%15.10f",XC);
fclose(XCDATA_OUT);


/*dependent variables*/
YY = -1*ones(N,CT);
YC = -1*ones(N,T);   /*product category purchase*/
YB = zeros(N,BT);  /*brand purchase*/

VU = zeros(N,CT);  /*latent utilities for v and u*/
VV = zeros(N,T);   /*latent utilities for v */
UU = zeros(N,BT);  /*latent utilities for u */


MUD = zeros(B,1);

SUM = zeros(C,1);

/*data generation of product category and brand purchases*/
for(i=0; i<N; ++i){
  TI = TT[i][];
  BTI = B*TI;

  XCI = XC[i][]';
  XBI = XB[i*Q:(i+1)*Q-1][0:BT-1]'; //  BT × Q

  YYI = -1*ones(CT,1);  /*category and brand purchase data for each consumer*/
  YCI = -1*ones(T,1);  /*category purchase data for each consumer*/
  YBI = zeros(BT,1);  /*brand purchase data for each consumer*/
  
  VUI = zeros(CT,1);  /*latent category and brand utilities for each consumer*/
  VVI = zeros(T,1);	 /*latent category utilities for each consumer*/
  UUI = zeros(BT,1);  /*latent brand utilities for each consumer*/

  BEI = BE[i][]';
  GAI = GA[i][]';
  
  for(u=0; u<TI; ++u){
    XCIT = XCI[u*J:(u+1)*J-1][];    
    XBIT = XBI[u*B:(u+1)*B-1][];
  
    YYIT = zeros(C,1);
    YCIT = 0;  /*category purchase data for each consumer at each purchase occasion*/
	YBIT = zeros(B,1);	/*brand purchase data for each consumer at each purchase occasion*/
	
	UISM = zeros(BM,1);
	
    VUIT = zeros(C,1);

    a = u + 1;
    if (a<=M) {
      S1 = a-1;
      for(v=0; v<S1; ++v){
        UISM[v*B:(v+1)*B-1][] = UUI[(u-v-1)*B:(u-v)*B-1][];
      }
    }
    if (a > M) {
      for(v=0; v<M; ++v){
        UISM[v*B:(v+1)*B-1][] = UUI[(u-v-1)*B:(u-v)*B-1][];
      }
    } 

    MUV = XCIT'*BEI;
    MUU = XBIT*GAI + LAM*UISM;
    MUVU = MUV | MUU;
	
    EP = choleski(SIG)*rann(C,1);
	
	VUIT = MUVU + EP;

    VVIT = VUIT[0][];
    UUIT = VUIT[1:C-1][];

	if (VVIT < 0){
	  YCIT = 0;
  	  YBIT = zeros(B,1); /*Brand purchase data is 0 if no category purchase occurs*/
	}

    if (VVIT > 0){
      YCIT = 1;

      MAXU = max(UUIT);  /*Maximum value of brand latent utility*/
      for(d=0; d<B; ++d){
        if (UUIT[d][0] == MAXU){  // When a category purchase occurs, the brand with the maximum utility is purchased
	  	  YBIT[d][] = 1;
	    }
        if (UUIT[d][0] > 0){  // also, all brands with higher than zero are purchased
	  	  YBIT[d][] = 1;
	    }
      }
	}

    YBI[u*B:(u+1)*B-1][] = YBIT;

	YYIT[0][] = YCIT;
	YYIT[1:C-1][] = YBIT;

  YYI[u*C:(u+1)*C-1][] = YYIT;
  YCI[u][] = YCIT;

  VUI[u*C:(u+1)*C-1][] = VUIT;
  VVI[u][] = VVIT;
  UUI[u*B:(u+1)*B-1][] = UUIT;
  }

YY[i][]	= YYI';
YC[i][]	= YCI';
YB[i][] = YBI';

VU[i][]	= VUI';
VV[i][]	= VVI';
UU[i][] = UUI';
}


YYDATA_OUT = fopen("(file path)\YYDATA_VALIDATION.txt","w");
fprint(YYDATA_OUT,"%3.0f",YY);
fclose(YYDATA_OUT);

YCDATA_OUT = fopen("(file path)\YCDATA_VALIDATION.txt","w");
fprint(YCDATA_OUT,"%3.0f",YC);
fclose(YCDATA_OUT);

YBDATA_OUT = fopen("(file path)\YBDATA_VALIDATION.txt","w");
fprint(YBDATA_OUT,"%3.0f",YB);
fclose(YBDATA_OUT);

////////////////////////////// end of validation data generation ///////////////////////////////////


//////////////////////////////  calibration data  ///////////////////////////////////


TT = T*ones(N,1); 

TTDATA_OUT = fopen("(file path)\TTDATA_CALIBRATION.txt","w");
fprint(TTDATA_OUT,"%5.0f",TT);
fclose(TTDATA_OUT);


BE = zeros(N,J);
for(i=0; i<N; ++i){
  BEI = zeros(J,1);
  BEI = TH + choleski(VB)*rann(J,1);

BE[i][] = BEI';
}


GA = zeros(N,Q);
for(i=0; i<N; ++i){
  GAI = zeros(Q,1);
  GAI = PH + choleski(VG)*rann(Q,1);

GA[i][] = GAI';
}


TRUEBE_OUT = fopen("(file path)\TRUEBE_CALIBRATION.txt","w");
fprint(TRUEBE_OUT,"%10.5f",BE);
fclose(TRUEBE_OUT);

TRUEGA_OUT = fopen("(file path)\TRUEGA_CALIBRATION.txt","w");
fprint(TRUEGA_OUT,"%10.5f",GA);
fclose(TRUEGA_OUT);


/*matrices of the explanatory variables for product category purchase*/
XB = zeros(N*Q,BT);  /*matrix for brand purchase*/
XC = zeros(N,J*T);  /*matrix for product category purchase*/

for(i=0; i<N; ++i){
  TI = TT[i];
  XBI = zeros(BT,Q);
  XCI = zeros(J*T,1);
  
  for(u=0; u<TI; ++u){
	XBIT = zeros(B,3);
    XCIT = zeros(J,1);
	
    for(d=0; d<B; ++d){
      XITB = zeros(1,3);

      TEM = 0.5*rann(1,1);
	  XITB[0][0] = TEM;

      TEM = 0.5*rann(1,1);
	  XITB[0][1] = TEM;

      TEM = 0.5*rann(1,1);
	  XITB[0][2] = TEM;

	  XBIT[d][] = XITB;
	}  /*B*/
	
	XBIT = unit(B) ~ XBIT;

    XCIT[0][0] = 1.0;	/*intercept*/
    for(d=1; d<J; ++d){
      TEM = 0.5*rann(1,1);
      XCIT[d][0] = TEM;  
    }

  XBI[u*B:(u+1)*B-1][] = XBIT;
  XCI[u*J:(u+1)*J-1][] = XCIT;
  }  /*TI*/

XB[i*Q:(i+1)*Q-1][0:BT-1] = XBI';
XC[i][] = XCI';
}

XBDATA_OUT = fopen("(file path)\XBDATA_CALIBRATION.txt","w");
fprint(XBDATA_OUT,"%15.10f",XB);
fclose(XBDATA_OUT);

XCDATA_OUT = fopen("(file path)\XCDATA_CALIBRATION.txt","w");
fprint(XCDATA_OUT,"%15.10f",XC);
fclose(XCDATA_OUT);



/*dependent variables*/
YY = -1*ones(N,CT);
YC = -1*ones(N,T);   /*product category purchase*/
YB = zeros(N,BT);  /*brand purchase*/

VU = zeros(N,CT);  /*latent utilities for v and u*/
VV = zeros(N,T);   /*latent utilities for v */
UU = zeros(N,BT);  /*latent utilities for u */


MUD = zeros(B,1);

SUM = zeros(C,1);

/*data generation of product category and brand purchases*/
for(i=0; i<N; ++i){
  TI = TT[i][];
  BTI = B*TI;

  XCI = XC[i][]';
  XBI = XB[i*Q:(i+1)*Q-1][0:BT-1]'; //  BT × Q

  YYI = -1*ones(CT,1);  /*category and brand purchase data for each consumer*/
  YCI = -1*ones(T,1);  /*category purchase data for each consumer*/
  YBI = zeros(BT,1);  /*brand purchase data for each consumer*/
  
  VUI = zeros(CT,1);  /*latent category and brand utilities for each consumer*/
  VVI = zeros(T,1);	 /*latent category utilities for each consumer*/
  UUI = zeros(BT,1);  /*latent brand utilities for each consumer*/

  BEI = BE[i][]';
  GAI = GA[i][]';
  
  for(u=0; u<TI; ++u){
    XCIT = XCI[u*J:(u+1)*J-1][];    
    XBIT = XBI[u*B:(u+1)*B-1][];
  
    YYIT = zeros(C,1);
    YCIT = 0;  /*category purchase data for each consumer at each purchase occasion*/
	YBIT = zeros(B,1);	/*brand purchase data for each consumer at each purchase occasion*/
	
	UISM = zeros(BM,1);
	
    VUIT = zeros(C,1);

    a = u + 1;
    if (a<=M) {
      S1 = a-1;
      for(v=0; v<S1; ++v){
        UISM[v*B:(v+1)*B-1][] = UUI[(u-v-1)*B:(u-v)*B-1][];
      }
    }
    if (a > M) {
      for(v=0; v<M; ++v){
        UISM[v*B:(v+1)*B-1][] = UUI[(u-v-1)*B:(u-v)*B-1][];
      }
    } 

    MUV = XCIT'*BEI;
    MUU = XBIT*GAI + LAM*UISM;
    MUVU = MUV | MUU;
	
    EP = choleski(SIG)*rann(C,1);
	
	VUIT = MUVU + EP;

    VVIT = VUIT[0][];
    UUIT = VUIT[1:C-1][];

	if (VVIT < 0){
	  YCIT = 0;
  	  YBIT = zeros(B,1); /*Brand purchase data is 0 if no category purchase occurs*/
	}

    if (VVIT > 0){
      YCIT = 1;

      MAXU = max(UUIT);  /*Maximum value of brand latent utility*/
      for(d=0; d<B; ++d){
        if (UUIT[d][0] == MAXU){  // When a category purchase occurs, the brand with the maximum utility is purchased
	  	  YBIT[d][] = 1;
	    }
        if (UUIT[d][0] > 0){  // also, all brands with higher than zero are purchased
	  	  YBIT[d][] = 1;
	    }
      }
	}

    YBI[u*B:(u+1)*B-1][] = YBIT;

	YYIT[0][] = YCIT;
	YYIT[1:C-1][] = YBIT;

  YYI[u*C:(u+1)*C-1][] = YYIT;
  YCI[u][] = YCIT;

  VUI[u*C:(u+1)*C-1][] = VUIT;
  VVI[u][] = VVIT;
  UUI[u*B:(u+1)*B-1][] = UUIT;
  }

YY[i][]	= YYI';
YC[i][]	= YCI';
YB[i][] = YBI';

VU[i][]	= VUI';
VV[i][]	= VVI';
UU[i][] = UUI';
}


YYDATA_OUT = fopen("(file path)\YYDATA_CALIBRATION.txt","w");
fprint(YYDATA_OUT,"%3.0f",YY);
fclose(YYDATA_OUT);

YCDATA_OUT = fopen("(file path)\YCDATA_CALIBRATION.txt","w");
fprint(YCDATA_OUT,"%3.0f",YC);
fclose(YCDATA_OUT);

YBDATA_OUT = fopen("(file path)\YBDATA_CALIBRATION.txt","w");
fprint(YBDATA_OUT,"%3.0f",YB);
fclose(YBDATA_OUT);

////////////////////////////////// end of calibration data generation ///////////////////////////////////////////




}
